<?php

class patch {

	private $_baseurl = 'http://%s/pub/security/nagios/patches';
	private $_host = 'ftp.momo-i.org';
	private $_UA = "Mozilla/5.0 Nagios Japanese Patch Checker/1.0";

	private function __construct()
	{

	}

	static public function get_patch($version)
	{
		$self = new self();
		return $self->_get_newversion($version);
	}

	private function _get_newversion($version)
	{
		$msg = "利用可能な最新の日本語化パッチは存在しません。";
		$baseurl = sprintf($this->_baseurl, $this->_host);
		$url = sprintf('%s/nagios-jp-%s.patch.gz', $baseurl, $version);
		if(extension_loaded('curl'))
		{
			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_FAILONERROR, true);
			curl_setopt($ch, CURLOPT_USERAGENT, $this->_UA);
			curl_setopt($ch, CURLOPT_NOBODY, true);
			curl_exec($ch);
			$info = curl_getinfo($ch);
			if($info['http_code'] != 200)
			{
				return $msg;
			}
			$msg = sprintf('日本語化パッチの<a href="%s">ダウンロード</a>が可能です。', $url);
			return $msg;
		}
		elseif(function_exists('file_get_contents') && ini_get('allow_url_fopen') == true)
		{
			$header = "User-Agent: $UA\r\n";
			$opts = [
				'http' => [
					'method' => 'HEAD',
					'header' => $header
				]
			];
			$cn = stream_context_create($opts);
			if(@file_get_contents($url, false, $cn) !== false)
			{
				$msg = sprintf('日本語化パッチの<a href="%s">ダウンロード</a>が可能です。', $url);
				return $msg;
			}
			return $msg;
		}
		return "日本語化パッチ確認のための機能が利用できません。<a href=\"http://ftp.momo-i.org/pub/security/nagios/patches/\"></a>より確認して下さい。";
	}

}
